/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

///////////////////////////////////////////////////////////////////////////
// Filename	: CDisplay.cpp
// Created	: Tuesday, June 17th, 1997
// Description: A window class to display images.
// 
// Copyright  Nuria Oliver		nuria@media.mit.edu
///////////////////////////////////////////////////////////////////////////
// CDisplay.cpp : implementation file
//

#include "stdafx.h"
#include "Display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Static class variables
short CDisplay::defaultBorderWidth = 5;

/////////////////////////////////////////////////////////////////////////////
// CDisplay


CDisplay::CDisplay()
{
	m_bValidDib = NEVER;	// Dib is not valid at the beginning
}

CDisplay::~CDisplay()
{
}

/////////////////////////////////////////////////////////////////////////////
// CDisplay message handlers

BOOL CDisplay::Create(BITMAPINFO_8 &bmInfo, BOOL bMatchScreen)
{
	// Create the dib
	BOOL	err =  m_dib.Create(bmInfo, bMatchScreen);
	m_size = m_dib.GetDimensions();
	return err;
}

void CDisplay::AttachMemToDib(LPVOID bits, BOOL bAlwaysValid)
{
	m_dib.AttachMemory((LPBYTE)bits, bAlwaysValid);
	m_bValidDib = (bAlwaysValid) ? ALWAYS : ONCE;
}

