///////////////////////////////////////////////////////////////////////////
// Filename	: ImgWnd.cpp
// Created	: Tuesday, June 17th, 1997
// Description: A window class to display images.
// 
//  Vasanth Philomin 1997, vasi@cs.umd.edu
///////////////////////////////////////////////////////////////////////////
// ImgWnd.cpp : implementation file
//

#include "stdafx.h"
#include "Grab.h"
#include "ImgWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Static class variables
short CImgWnd::defaultBorderWidth = 4;

IMPLEMENT_DYNCREATE(CImgWnd, CFrameWnd)

/////////////////////////////////////////////////////////////////////////////
// CImgWnd

BEGIN_MESSAGE_MAP(CImgWnd, CFrameWnd)
	//{{AFX_MSG_MAP(CImgWnd)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImgWnd message handlers

BOOL CImgWnd::Create(const char *strTitle, 
					 const CPoint &topLeftCorner, 
					 BITMAPINFO_8 &bmInfo, 
					 BOOL bMatchScreen)
{
	DWORD dwStyle = WS_OVERLAPPEDWINDOW | WS_VISIBLE;

	// Create the dib by calling the parent's function
	CDisplay::Create( bmInfo, bMatchScreen );
	
	CSize size = m_dib.GetDimensions();

	CRect rectWindow(topLeftCorner.x, topLeftCorner.y, topLeftCorner.x + size.cx,
							topLeftCorner.y + size.cy);

	// Inflate rectangle for the border
	rectWindow.InflateRect(0, 0, defaultBorderWidth, defaultBorderWidth);

	// Get change in size due to window style
	AdjustWindowRect(&rectWindow, dwStyle, FALSE);	// FALSE => No menu in window

	// Move back to our chosen position
	rectWindow = CRect(topLeftCorner.x, topLeftCorner.y, topLeftCorner.x + rectWindow.Width(),
							topLeftCorner.y + rectWindow.Height());

	// Now create the window
	return CFrameWnd::Create(NULL, strTitle, dwStyle, rectWindow);
}

void CImgWnd::OnPaint() 
{
	// Proceed only if Dib is valid
	if (m_bValidDib == NEVER)
		return;

	CPaintDC dc(this); // device context for painting
	
	m_dib.Draw(&dc, 0, 0);


	if (m_bValidDib == ONCE)
		m_bValidDib = NEVER;
	
	// Do not call CFrameWnd::OnPaint() for painting messages
}
