/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

///////////////////////////////////////////////////////////////////////////
// Filename	: StaticFrame.h
// Created	: Tuesday, June 17th, 1997
// Description: A frame class to display images. The frame is glued to a dialog.
// 
//  Vasanth Philomin 1997, vasi@cs.umd.edu
///////////////////////////////////////////////////////////////////////////
// StaticFrame.h : header file
//
#ifndef _STATICFRAME_H
#define _STATICFRAME_H


#include "Display.h"

/////////////////////////////////////////////////////////////////////////////
// CStaticFrame window

class CStaticFrame : public CStatic, public CDisplay
{
	
	DECLARE_DYNCREATE(CStaticFrame)
		
		// Construction
public:
	
	CStaticFrame() : CDisplay()  { m_pDlg = NULL;}
	CStaticFrame(CDialog *pDlg);
	
	// Attributes
public:
	
	void Refresh ( ) {
		RedrawWindow(NULL,NULL,RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW );
	}
	virtual void CenterWindow( CWnd* pAlternateOwner = NULL );
	virtual Create(BITMAPINFO_8 &bmInfo, BOOL bMatchScreen);
	
	// Operations
public:
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticFrame)
	//}}AFX_VIRTUAL
	
	// Implementation
public:
	virtual ~CStaticFrame();
	
	// Generated message map functions
protected:
	//{{AFX_MSG(CStaticFrame)
	afx_msg void OnPaint();
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()
		CDialog	*m_pDlg;
	
};

/////////////////////////////////////////////////////////////////////////////
#endif
