/***************************************************************************
 *
 * Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
 * rights reserved.
 *
 * Developed  by the Perceptual Computing Section
 * at the Media Laboratory, MIT, Cambridge, Massachusetts.
 *
 * Permission to use, copy,  or modify this software and  its documentation
 * for  educational  and  research purposes only and without fee  is hereby
 * granted, provided  that this copyright notice and the original authors's
 * names appear  on all copies and supporting documentation.  If individual
 * files are  separated from  this  distribution directory  structure, this
 * copyright notice must be included.  For any other uses of this software,
 * in original or  modified form, including but not limited to distribution
 * in whole or in  part, specific  prior permission  must be  obtained from
 * MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
 *   basis  of  a commercial  software  or  hardware product  without first
 * obtaining appropriate licenses  from MIT.  MIT. makes no representations
 * about the suitability of this  software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 **************************************************************************/

///////////////////////////////////////////////////////////////////////////
// Filename	: CStaticFrameBB.h
// Created	: 07 07 1997
// Description: A static frame class to display images.
// 
//  Nuria Oliver 1997, nuria@media.mit.edu
//  Vasanth Philomin 1997, vasi@cs.umd.edu
///////////////////////////////////////////////////////////////////////////
// CStaticFrameBB.h : header file
//
#ifndef _CSTATICFRAMEBB_H
#define _CSTATICFRAMEBB_H

#include "StaticFrame.h"
#include "UPoint.h"

/////////////////////////////////////////////////////////////////////////////
// CStaticFrameBB frame


class CStaticFrameBB : public CStaticFrame
{

// Attributes
public:
	void SetRect(CRect &rect)	{ m_rect = CRect( max(0,rect.left), max(0,rect.top),
												min(m_size.cx,rect.right),min(m_size.cy,rect.bottom)); }
	void SetEigPoints(TPointArray &arrEigPoint)	{ m_arrEigPoint.Copy( arrEigPoint ); }
	CStaticFrameBB();
	CStaticFrameBB(CDialog *pDlg);
	void Create(BITMAPINFO_8 &bmInfo, BOOL bMatchScreen = TRUE, BOOL bDrawBB = FALSE, BOOL bDrawEig = FALSE);
	void SetDrawBB() { m_bDrawBB = TRUE; }
	void SetDrawEig() { m_bDrawEig = TRUE; }
	void UnsetDrawBB() { m_bDrawBB = FALSE; }
	void UnsetDrawEig() { m_bDrawEig = FALSE; }
	void Refresh ( ) {
		//RedrawWindow(NULL,NULL,RDW_INVALIDATE);
		CStaticFrame::Refresh();
	}

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticFrameBB)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CStaticFrameBB(){;}

	// Generated message map functions
	//{{AFX_MSG(CStaticFrameBB)
	afx_msg void OnPaint();
	//}}AFX_MSG

private:
	CBrush	m_brush;
	CPen	m_pen;
	CRect   m_rect;
	BOOL    m_bDrawBB;
   	BOOL    m_bDrawEig; 
	TPointArray m_arrEigPoint;

	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////

#endif
