/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// StaticFrameBBDialog.h: interface for the CStaticFrameBBDialog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATICFRAMEBBDIALOG_H__9C1E96BD_FDF3_11D0_ACB2_00A0C9064703__INCLUDED_)
#define AFX_STATICFRAMEBBDIALOG_H__9C1E96BD_FDF3_11D0_ACB2_00A0C9064703__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DisplayDialog.h"
#include "StaticFrameBB.h"

class CStaticFrameBBDialog : public CDisplayDialog  
{
public:
	
	CStaticFrameBBDialog(CWnd* pParent = NULL, int	id = 0);
	CStaticFrameBBDialog(CDialog* pDlg, int		id = 0);
	virtual ~CStaticFrameBBDialog();
	
	virtual void CenterBitmap();
	virtual BOOL Create( int nPixSize, int Width, int Height,
		BOOL bMatchScreen = TRUE, BOOL bDrawBB = FALSE, BOOL bDrawEig = FALSE);
	void	Quit() { OnClose();}
	
	// Dialog Data
	//{{AFX_DATA(CStaticFrameBBDialog)
	enum { IDD = IDD_STATICFRAME };
	CStaticFrameBB	m_picLiveImg;
	//}}AFX_DATA
	
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticFrameBBDialog)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Generated message map functions
	//{{AFX_MSG(CStaticFrameBBDialog)
	afx_msg void OnClose();
	afx_msg void OnPaint();
	//}}AFX_MSG
	void OnRefresh();
	DECLARE_MESSAGE_MAP()
		
private:
	void CleanUp();
};

#endif // !defined(AFX_STATICFRAMEBBDIALOG_H__9C1E96BD_FDF3_11D0_ACB2_00A0C9064703__INCLUDED_)
