/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// StaticFrameDialog.cpp: implementation of the CStaticFrameDialog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Lafter.h"
#include "StaticFrame.h"
#include "StaticFrameDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStaticFrameDialog::CStaticFrameDialog(CWnd* pParent, int	id)
:CDisplayDialog( pParent, id )
{
}

CStaticFrameDialog::CStaticFrameDialog(CDialog* pDlg, int	id)
:CDisplayDialog(pDlg, id), m_picLiveImg( this )
{
}

CStaticFrameDialog::~CStaticFrameDialog()
{
	
}

void CStaticFrameDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStaticFrameDialog)
	DDX_Control(pDX, IDC_LIVE_FRAME, m_picLiveImg);
	//}}AFX_DATA_MAP
}


BOOL CStaticFrameDialog::Create( int nPixSize, int Width, int Height )
{
	
	BOOL		err = CDisplayDialog::Create( nPixSize, Width, Height );
	m_picLiveImg.Create(m_stdBmInfo, FALSE);
	
	return err;
}

void CStaticFrameDialog::CenterBitmap()
{
	m_picLiveImg.CenterWindow( this );
}


BEGIN_MESSAGE_MAP(CStaticFrameDialog, CDialog)
//{{AFX_MSG_MAP(CStaticFrameDialog)
ON_WM_PAINT()
ON_WM_CLOSE()
//}}AFX_MSG_MAP
ON_MESSAGE(WM_REFRESH, OnRefresh)
END_MESSAGE_MAP()


void CStaticFrameDialog::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	CDisplayDialog::OnClose();
}

void CStaticFrameDialog::CleanUp()
{
}

void CStaticFrameDialog::OnPaint() 
{
	// TODO: Add your message handler code here
	
	// Do not call CDialog::OnPaint() for painting messages
	RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW );
}

void CStaticFrameDialog::OnRefresh()
{
	m_picLiveImg.Refresh();
}
