/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

//
//       File : UCDeviceComm.h
//       Goal : Generic serial communication setting
//		 Date : 07 07 97
//
//	Nuria Oliver 1997, nuria@media.mit.edu
//				Vasanth Philomin 1997, vasi@cs.umd.edu
//


#ifndef _UCDEVICECOMM_H
#define _UCDEVICECOMM_H

#include "WinBase.h"

// Project includes
#include "UErrors.h"

// Error numbers from 1970 to 1979
static const short     kErrIOPending = 1970;
static const short     kErrTimeOut   = 1971;

const DWORD kEVISmallTimeOut    = 4000;	// RS232 default timeout

class CDeviceComm	{
public:
	ErrorNumber GetBuffer(char *buf, int length, DWORD *nRead, DWORD timeout = kEVISmallTimeOut);
	BOOL Purge();
	CDeviceComm(void);
	~CDeviceComm (void);
	BOOL Open (char *PortName, int Speed);
	void Close (void);
	BOOL GetChar (char &ch);
	void PutChar (char ch);
	ErrorNumber PutBuffer (char *buf, int length);
	
protected:
	HANDLE m_hPort;
};

#endif