/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// UStatistics.h
//
// Date : 02 07 97
//
// Nuria Oliver 1997, nuria@media.mit.edu

#ifndef _USTATISTICS_H_
#define _USTATISTICS_H_

#ifndef TVGAUSSTYPE
#define TVGAUSSTYPE float
#endif

#include "UVector2.h"
#include "UMatrix3.h"
#include "UMatrix4.h"
#include "UGaussianInv.h"

typedef TVector2<TVGAUSSTYPE>       TVector2f;
typedef TMatrix3<TVGAUSSTYPE>       TMatrix3f;
typedef TMatrix4<TVGAUSSTYPE>       TMatrix4f;
typedef TGaussianInv<TVGAUSSTYPE>   TGaussianf;

#endif /* _TStatistics2_H_ */

