// File       : UTypesMutex.h
// Creation   : Feb 1997
// Creator    : N.OLIVER
// Goal       : declares TTypesMutex virtual class. A class that defines the
//              mutex types used by the learners
//
// Tab        : yes

#ifndef _UTYPESMUTEX_H
#define _UTYPESMUTEX_H

// project includes
#include "UErrors.h"
#include "UHistogram.h"
#include "UBitMap.h"
#include <afxmt.h>

// Define the structure with the Mutex that is going to be
// accessed by both the learner and the main process

typedef struct {
     CRITICAL_SECTION      mutex;        // Mutual exclusion semaphore
	CRect	        roi;          // ROI
        float           density;      // density of the region of interest
} TROIMutex;

typedef struct {
  CRITICAL_SECTION  mutex;
  int      numGauss;
  TGaussianf*  gauss;
  float*      w;
  float       maxDist;
} TMixGaussMutex;

typedef struct {
        CRITICAL_SECTION      mutex;        // Mutual exclusion semaphore
	int	        index;        // Index to the histogram to be read 
} TMaxLikeIndex;

// Define the structure with the Mutex that is going to be
// accessed by both the learner and the main process

typedef struct {
        CRITICAL_SECTION      mutex;       // Mutual exclusion semaphore
	int	        flag;        // flag
} TFlagMutex;

#endif
