#ifndef _OPR_H_
#define _OPR_H_

/**

History:

$Log: opr.h $
Revision 1.14  1997/01/21 18:09:12  ADR
- Fix Duration and Delay OPRs which now have a LOW/HIGH value.
Revision 1.13  1997/01/17 12:43:04  ADR
- added the strobe1 and strobe2 parameters.
Revision 1.12  1996/12/23 17:34:16  ADR
- added EX_LD_VGALUT
Revision 1.11  1996/11/19 17:22:34  ADR
- Added definition for EX_MYUSER
Revision 1.10  1996/09/26 16:18:20  SINBAL
added opr extrig.active
Revision 1.9  1996/09/17 15:59:58  MM
Added JPEGENCODESETUP and JPEGENCODERUN oprs.
Revision 1.8  1996/08/02 00:37:30  MM
Added VCPI_BUSY & VCPI_DONE to VCPI_ERROR.
Revision 1.7  1996/07/24 16:52:52  MM
New JPEG_CODE_STATE typedef added.
Revision 1.6  1996/07/22 11:52:26  ADR
- Added the EX_SETEVENTFCT definition.

   1.0   September, 1988, Gag

   1.1   December 22, 1988, Gag
         Bug: Incorrect values of following constants:
         AMASK, FMASK, AFBPAGE, FBTYPE, MEMSIZ

   1.2   August 23, 1989, Gag
         Add definition of the extended operator symbols for ext_inq.

   1.3   Nov 27, 1989, Gag
         Revision for ODX V:4.00

   1.4   March 4, 1990, Gag
         Final revision for ODXVER 4.00

   1.5   June 14, 1990, Gag
         Add EX_MATHOP, EX_RMW* 

   1.6   November 28th, 1990, ADR
         Added new definitions:  OPR_FIRST, OPR_LAST
         Complete the EX_ list

   1.7   March 10th, 1992, ADR
         Added: KEYING parameter (#73).
                MEMPAGE parameter (#74)
                MEMPAGECNT parameter (#75)
                MEMSIZCNT parameter (#76)
                FZOOMOUT parameter (#77)
                FZOOMOUTSIZ parameter (#78)

   1.8   May 4th, 1992, ADR
         Modified: KEYING -> KEYING_MODE
         Added:    KEYING_COLOR  (#74)
         Moved MEMPAGE, MEMPAGECNT, MEMSIZCNT, FZOOMOUT and
               FZOOMOUTSIZ opr number down '1'.

   1.9   May 26th, 1992, ADR
         Added AIC (Analog Input Conditioning) parameters.

   2.0   August 20th, 1992, ADR
         Added DMASK and OCR parameters.

   2.1   October 29th, 1992, ADR
         Added VIDIN.DPRMIN and VIDIN.DPRMAX parameters.
         Added typedef structure definitions.

   2.2   December 18th, 1992, ADR
         Added VIDOUT.DPRMIN, VIDOUT.DPRMAX, VIDOUT.DPR and
         VIDOUT.HSFCNT parameters.

   2.3   February 18th, 1993, ADR
         Added the definitions for fbgrabalu, fbgrabdilut, pixbltpage and
         hwconfig.

   2.4   April 13th, 1993, ADR
         Added PMW parameters.

   2.5   June 9th, 1993, ADR
         Added the KEYING.ALIGN.X and KEYING.ALIGN.Y parameters.

   2.6   October 14th, 1993, ADR
         Added FI.COUNT and FI.POLARITY Parameter.

   2.7   February 24th, 1994, ADR
         Added the Communication Failure ODx Error Definition: ICOMMERR.

   2.8   March 15th, 1994, ADR
         Added the definitions for 'setfbsize' and 'rdfbhisto'.
         Added the opr: PROCESSOR

   2.9   March 23rd, 1994, ADR
         Added the Communication Failure of an on board processor:
         IAUXPRO (ie. if DSP fails then the GSP will report this error)
         Added definition of clrhostint function.

   2.10  April 8th, 1994, ADR
         Added the new OPRs: AAFILTER_ENABLE and AAFILTER_FREQUENCY

   2.11  May 3rd, 1994, ADR
         Added the new OPRs: CAMERA_COUNT and CAMERA_NUMBER.

   2.12  June 22nd, 1994, ADR
         Added the new OPRs: FI_EXPOSURETIME_LOW and FI_EXPOSURETIME_HIGH.

   2.13  July 18th, 1994, ADR
         Added the new OPR: ACQATTRIBUTE
         Final revision for ODXVER 4.35

   2.14  August 11th, 1994, ADR
         Added the FI_EXPOSURE OPR.

   2.15  September 1st, 1994, ADR
         Added the EX_LAST Definition.

   2.20  December 8th, 1994, ADR
         Added the EX_ODXABORT Definition.

   2.21  April 11th, 1995, ADR
         Added the OPr EVENTMODE

   2.22  May 15th, 1995, ADR
         Added the OPRs KEYING_COLOR_RED/GREEN/BLUE.
         The Opr KEYING_COLOR is now named KEYING_COLOR_INDEX.

   2.23  May 24th, 1995, ADR
         Added the OPRs EXTRIG_ENABLE and EXTRIG_FUNCTION
         Added the OPRs CAMSCNT_ANALOG and CAMSCNT_DIGITAL.

   2.24  May 29th, 1995, ADR
         Added EX_RDFBRLEN.

   2.25  June 12th, 1995, ADR
         Added the ACQMETHOD OPR.

   2.26  June 27th, 1995, ADR
         Some definitions are not defined anymore if the Cool Vision
         header type.h has been included (those definitions are part
         of an enumeration).
         
   2.26a July 25th, 1995, RH
         Added #ifndef _OPR_H_...

   2.27  August 9th, 1995, ADR
         Added the OPRs: ACQFRAMERATE, ACQSCALE_H, ACQSCALE_V.
         Added the definition: EX_ACQSCALE.

   2.28  Sept 21st, 1995, MM
         Added the definition: EX_SET_VIEW_HWND.

   2.29  October 11th, 1995, ADR
         Added the OPR: ACQLINE.
   2.30  October 18th, 1995, BSD
         added fbcycle_currentfwin and fbcycle_currentfb andEX_SETFBCYCLE  75

   2.31  Oct 18th , 1995
         -removed what was added on previously,  added opr fbcycle

   2.32  October 19th, 1995, ADR
         - OPR_LAST is now set to FBCYCLEINDEX.
         - SETFBCYCLE replaced by DEFFBCYCLE.

   2.32  October 25th, 1995, ADR
         - FBCYCLEINDEX is now called FBCYCLE_INDEX.
         - New OPR FBCYCLE_COUNT

   2.33  November 1st, 1995, ADR
         - Added the definitions for: FB_RGB_565, FB_YUYV, FB_UYVY,
                                      FB_YVYU, FB_YUY2, FB_YUV_PLANAR

   2.34  March, 27th, 1996, JPC
		 - Added the defintion: EX_JPEG_INIT, EX_JPEG_ENCODE, EX_JPEG_DECODE, EX_JPEG_TERM

   2.35  April, 1st, 1996, JPC
       = Added conditional compilation for data types
            VCPI_ERROR 
            JPEG_CODE_TYPE
            JPEG_COLOR_FORMAT
**/
/* Compatibility definitions */
#define  AFB             0
#define  OMR             7
#define  AFBPAGE        52          
#define  AMASK          54

/* Symbols for opr_set, opr_inq */
#define  DFB             1
#define  ILUTN           2
#define  OLUTN           3
#define  CGA_GRL         4
#define  CGA_OPM         5
#define  FMASK           6
#define  ICR             8
#define  CPOS_X          9
#define  CPOS_Y         10
#define  PWIN_XMIN      11
#define  PWIN_YMIN      12
#define  PWIN_XLEN      13
#define  PWIN_YLEN      14
#define  DWIN_XMIN      15
#define  DWIN_YMIN      16
#define  DWIN_XLEN      17
#define  DWIN_YLEN      18
#define  FWIN_XMIN      19
#define  FWIN_YMIN      20
#define  FWIN_XLEN      21
#define  FWIN_YLEN      22
#define  VID            23
#define  ODI            24
#define  FGON           25
#define  ERRNO          26
#define  FBCNT          27
#define  ILUTCNT        28
#define  OLUTCNT        29
#define  ILUTFORM       30
#define  OLUTFORM       31
#define  PIXSIZ         32
#define  MW             33
#define  MH             34
#define  ROA_RANGE      35
#define  ROA_OFFSET     36
#define  VIDIN_FORMAT   37
#define  VIDIN_HSF      38
#define  VIDIN_VSF      39
#define  VIDIN_HMIN     40
#define  VIDIN_VMIN     41
#define  VIDIN_HSFCNT   42
#define  VIDIN_VSFCNT   43
#define  VIDOUT_FORMAT  44
#define  VIDOUT_HSF     45
#define  VIDOUT_VZF     46
#define  VIDOUT_HMIN    47
#define  VIDOUT_VMIN    48
#define  RESERVED_1     49
#define  RESERVED_2     50
#define  FBTYPE         51
#define  PFBPAGE        52
#define  MEMSIZ         53
#define  PMASK          54
#define  ACQMODE        55
#define  ACQSTATUS      56
#define  BIN_GRL        57
#define  BIN_OPM        58
#define  DSPLEVEL       59
#define  DSPMODE        60
#define  ODXVER         61
#define  PSTEP          62
#define  VIDIN_HPIX     63
#define  VIDIN_VPIX     64
#define  VIDIN_DPR      65
#define  VIDOUT_HPIX    66
#define  VIDOUT_VPIX    67
#define  VIDOUT_HZF     68
#define  TEXT_XSIZ      69
#define  TEXT_YSIZ      70
#define  FFB            71
#define  PFB            72
#define  KEYING_MODE    73
#define  KEYING         KEYING_MODE    /* For Compatibility with opr.h v:1.7  */
#define  KEYING_COLOR   74
#define  KEYING_COLOR_INDEX   74

#define  MEMPAGE        75
#define  MEMPAGECNT     76
#define  MEMSIZCNT      77
#define  FZOOMOUT       78
#define  FZOOMOUTSIZ    79

#define  AIC_SATURATION 80
#define  AIC_HUE        81
#define  AIC_BRIGHTNESS_RED   82
#define  AIC_BRIGHTNESS_GREEN 83
#define  AIC_BRIGHTNESS_BLUE  84
#define  AIC_CONTRAST_RED     85
#define  AIC_CONTRAST_GREEN   86
#define  AIC_CONTRAST_BLUE    87
#define  AIC_OFFSET_RED       88
#define  AIC_OFFSET_GREEN     89
#define  AIC_OFFSET_BLUE      90
#define  AIC_RANGE_RED        91
#define  AIC_RANGE_GREEN      92
#define  AIC_RANGE_BLUE       93
#define  DMASK                94
#define  OCR                  95
#define  VIDIN_DPRMIN         96
#define  VIDIN_DPRMAX         97
#define  VIDOUT_DPRMIN        98
#define  VIDOUT_DPRMAX        99
#define  VIDOUT_DPR          100
#define  VIDOUT_HSFCNT       101
#define  PMW                 102
#define  KEYING_ALIGN_X      103
#define  KEYING_ALIGN_Y      104
#define  FI_COUNT            105
#define  FI_POLARITY         106
#define  PROCESSOR           107
#define  AAFILTER_ENABLE     108
#define  AAFILTER_FREQUENCY  109
#define  CAMERA_NUMBER       110
#define  CAMERA_COUNT        111
#define  FI_EXPOSURETIME_LOW 112
#define  FI_EXPOSURETIME_HIGH 113
#define  ACQATTRIBUTE         114
#define  FI_EXPOSURESTATUS    115   
#define  EVENTMODE            116
#define  KEYING_COLOR_RED     117
#define  KEYING_COLOR_GREEN   118
#define  KEYING_COLOR_BLUE    119
#define  EXTRIG_ENABLE        120
#define  EXTRIG_FUNCTION      121
#define  CAMSCNT_ANALOG       122
#define  CAMSCNT_DIGITAL      123
#define  ACQMETHOD            124
#define  ACQFRAMERATE         125
#define  ACQSCALE_H           126
#define  ACQSCALE_V           127
#define  ACQLINE              128
#define  FBCYCLE_INDEX        129
#define  FBCYCLE_COUNT        130
#define  EXTRIG_ACTIVE        131
#define  STROBE1_ENABLE       132
#define  STROBE1_POLARITY     133
#define  STROBE1_DURATION_LOW 134
#define  STROBE1_DURATION_HIGH 135
#define  STROBE1_DELAY_LOW    136
#define  STROBE1_DELAY_HIGH   137
#define  STROBE2_ENABLE       138
#define  STROBE2_POLARITY     139
#define  STROBE2_DURATION_LOW 140
#define  STROBE2_DURATION_HIGH 141
#define  STROBE2_DELAY_LOW    142
#define  STROBE2_DELAY_HIGH   143


#define  OPR_FIRST      AFB
#define  OPR_LAST       STROBE2_DELAY_HIGH 


/* Symbols for Standard Functions   */
#define  STD_AMOV       0
#define  STD_DRWBOX     2
#define  STD_EXT_INQ    7
#define  STD_FBGRAB     11
#define  STD_OPR_INQ    24
#define  STD_OPR_SET    25
#define  STD_PWIN       30
#define  STD_RDBUF      31
#define  STD_RDLINE     32
#define  STD_RDPIX      33
#define  STD_SELECT     36
#define  STD_TARGET     37
#define  STD_WTBUF      40
#define  STD_WTLINE     41
#define  STD_WTPIX      42
#define  STD_CONFIG     49
#define  STD_ODXID      59


/* Symbols for ext_inq */
#define  EX_CONVO       1
#define  EX_DRWCIRC     3
#define  EX_DRWDOTS     4
#define  EX_DRWLINE     5
#define  EX_DWIN        6
#define  EX_MORPHO      8
#define  EX_FBALU       9
#define  EX_FBCOPY      10
#define  EX_FBSET       12
#define  EX_FBSNAP      13
#define  EX_FBWAVE      14
#define  EX_FORMAT      15
#define  EX_FWIN        16
#define  EX_HISTO       17
#define  EX_LD_ILUT     18
#define  EX_LD_OLUT     19
#define  EX_LUTOP       20
#define  EX_MEMCLOSE    21
#define  EX_MEMOPEN     22
#define  EX_MEM         22
#define  EX_MEMROPEN    23
#define  EX_PAINT       26
#define  EX_PIXBLT      27
#define  EX_PIXPTN      28
#define  EX_PROFILE     29
#define  EX_RLEN        34
#define  EX_ROA         35
#define  EX_VIDIN       38
#define  EX_VIDOUT      39
#define  EX_LD_VGALUT   43
#define  EX_MYUSER      45
#define  EX_ACQSYNC     46
#define  EX_ODXUSER     47
#define  EX_DEFVIDOUT   48
#define  EX_RESET       50
#define  EX_CNTR        52
#define  EX_CNTRFIRST   53
#define  EX_CNTRNEXT    54
#define  EX_DEFVIDIN    55
#define  EX_DSPSYNC     56
#define  EX_EVENT       57 
#define  EX_LD_BLUT     58
#define  EX_TEXT        60
#define  EX_ZOOM        61 
#define  EX_MATHOP      62
#define  EX_RMWBUF      63
#define  EX_RMWLINE     64
#define  EX_RMWPIX      65
#define  EX_ODXMAP      66
#define  EX_FBDILUT     67
#define  EX_FBGRABALU   68
#define  EX_FBGRABDILUT 69
#define  EX_PIXBLTPAGE  70
#define  EX_HWCONFIG    71
#define  EX_VENDORID    72
#define  EX_RDFBHISTO   73
#define  EX_SETFBSIZE   74
#define  EX_DEFFBCYCLE  75
#define  EX_SETCAMERA   76
#define  EX_DEFCAMERA   77
#define  EX_RDVECTOR    78
#define  EX_WTVECTOR    79
#define  EX_DRIVERID    80
#define  EX_MDPIXBLT    81
#define  EX_ODXABORT    82
#define  EX_RDFBRLEN    83        
#define  EX_ACQSCALE    84
#define  EX_SET_VIEW_HWND    85
#define  EX_JPEGINIT		86
#define  EX_JPEGENCODE	87
#define  EX_JPEGDECODE	88
#define  EX_JPEGTERM		89
#define  EX_SETEVENTFCT  90
#define  EX_JPEGENCODESETUP		91
#define  EX_JPEGENCODERUN		92

#define  EX_LAST    EX_JPEGENCODERUN	

/******************************
      BIN.OPM
*******************************/
#ifndef TYPE_H       /* do not define if symbols are defined as enum in type.h */
#define BIN_LUT      0     
#define BIN_WHITE    1
#define BIN_BLACK    2
#define BIN_GRAY     3
#define BIN_BIT      4
#define BIN_NOTGRAY  5
#define BIN_NOTBIT   6
#endif

/******************************
      CGA.OPM: ppop
*******************************/
#define  PP_REPLACE  0
#define  PP_XOR      1
#define  PP_AND      2
#define  PP_OR       3
#define  PP_MIN      4
#define  PP_MAX      5
#define  PP_ADD      6
#define  PP_ADD_MAX  7
#define  PP_ABS      8
#define  PP_SUB      9

/******************************
      ERRNO
*******************************/
#define INOERR    0  /* No errors */
#define INOENT    1  /* Not an entry of ODX driver */
#define IIO       2  /* I/O Error */                     
#define IACCES    5  /* Permission Denied */             
#define IINVAL    7  /* Invalid Argument */              
#define INOSPC    9  /* No space left */                 
#define IACLIP    12 /* Area clipping occured */
#define ICOMMERR  15 /* Communication Failure   */
#define IAUXPRO   16 /* Auxiliary Processor Error   */


/******************************
      FBTYPE
*******************************/
#define FB_MONO          0
#define FB_RGBMULTI      1
#define FB_RGBPACK       2
#define FB_RGBA_5551     3
/* ??Bug: FB_RGBA_8888 corresponds to BGRA format */
#define FB_RGBA_8888     4
#define FB_RGB_565       5
#define FB_YUYV          6
#define FB_UYVY          7
#define FB_YVYU          8
#define FB_YUY2          9
#define FB_YUV_PLANAR   10
#define FB_RGB8_332     11
#define FB_BGRA_8888    12
#define FB_BGR8_332     13
#define FB_RGB88_332    14
#define FB_YUVA32 		15

/******************************
      FGON
*******************************/
#define FG_OFF       0
#define FG_ON        1
#define FG_RQST      2
#define FG_LOCK      3


/******************************
  Relative Direction Symbols
*******************************/
#ifndef TYPE_H       /* do not define if symbols are defined as enum in type.h */
#define DIR_STAY     0
#define DIR_E        1
#define DIR_NE       2
#define DIR_N        3
#define DIR_NW       4
#define DIR_W        5
#define DIR_SW       6
#define DIR_S        7
#define DIR_SE       8
#endif

/******************************
      MATHOP: op
*******************************/
#define  MO_NEG      0
#define  MO_ROL      1
#define  MO_ROR      2
#define  MO_SHL      3
#define  MO_SHR      4
#define  MO_SCALE    5
#define  MO_QUANTIZE 6
#define  MO_MAPPING  7
#define  MO_SEGMENT  8

/******************************
      MORPHO: mode
*******************************/
#define  MFO_MIN     0        
#define  MFO_MAX     1        
#define  MFO_MEDIAN  2        
#define  MFO_PREWITT 3        
#define  MFO_SOBEL   4        

/*****************************
	JPEG definitions
******************************/
#ifndef VCPIJPEG_H
typedef enum
		{
		 JPEG_YUV411 = 0,
		 JPEG_YUV422 = 1,
		 JPEG_MONO	 = 2
		}JPEG_COLOR_FORMAT;
      
typedef enum
		{
		 JPEG_ENCODE = 1,
		 JPEG_DECODE = 2
		}JPEG_CODE_TYPE;

typedef enum
		{
		 JPEG_STOP = 0,
		 JPEG_INIT = 1,
		 JPEG_SET  = 2
		}JPEG_CODE_STATE;
#endif /* ndef VCPIJPEG_H */

#ifndef VCPIERR_H
/* error return values */
typedef enum  {VCPI_DONE         =  3,
               VCPI_BUSY      	=  2,
					VCPI_TRUE 			=  1,
					VCPI_FALSE 			=  0,
					VCPI_OK 				=  0,
					VCPI_FAIL 			= -1,
					VCPI_NODLL 			= -2,
					VCPI_NOHARDWARE	= -3,
					VCPI_HARDERROR 	= -4,
					VCPI_RESETERROR	= -5,
					VCPI_NOTIMER 		= -6,
					VCPI_NOVXD 			= -7,
					VCPI_TIMEOUT 		= -8,
					VCPI_NOTIMPL 		= -9,          
					VCPI_STREAMERROR 	= -10,
					VCPI_AUTOERROR 	= -11,
					VCPI_INCLUDE 		= -12
				  } VCPI_ERROR;

#endif /* ndef VCPIERR_H */

#endif /* ndef _OPR_H_  */
